local MakePlayerCharacter = require "prefabs/player_common"

local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset( "SOUND", "sound/wilson.fsb" ),
        Asset( "ANIM", "anim/beard.zip" ),
		
		Asset( "ANIM", "anim/toph.zip" ),
		Asset("IMAGE", "images/colour_cubes/beaver_vision_cc.tex"),
}
local prefabs = {}
local start_inv = {
	-- Custom starting items
}

local function StreamlinedLeftClickPicker(inst, target_ent, pos)
    inst.Light:Enable(true)
	
	local pac = inst.components.playeractionpicker
    local useItem = inst.components.inventory:GetActiveItem()
	local actions = nil
	
	if not (useItem and useItem:IsValid()) then
		--This is where the earthbending magic happens
    	if target_ent and target_ent.components.workable and inst.components.worker:CanDoAction(target_ent.components.workable.action) then
        	actions = pac:SortActionList({target_ent.components.workable.action}, target_ent, nil)
    	--elseif target_ent and target_ent.components and (target_ent.components.mystery or target_ent.components.mystery_door) then
		--	actions = {ACTIONS.SPY}
		end
	end
	
	--A rather strange, but effective, way of using the GetClickActions script despite the left click override
	if actions == nil or #actions == 0 then
		pac.leftclickoverride = nil
		actions = pac:GetClickActions( target_ent, pos )
		pac.leftclickoverride = StreamlinedLeftClickPicker
	end
	
	return actions
end

local fn = function(inst)

	-- choose which sounds this character will play
	inst.soundsname = "willow"

	-- Minimap icon
	inst.MiniMapEntity:SetIcon( "toph.tex" )
	
	-- Stats	
	inst.components.health:SetMaxHealth(200)
	inst.components.hunger:SetMax(150)
	inst.components.sanity:SetMax(200)

	inst:AddComponent("worker")
	inst.components.worker:SetAction(ACTIONS.MINE, 6)
	inst.components.worker:SetAction(ACTIONS.DIG, 2)
	
	inst.components.playeractionpicker.leftclickoverride = StreamlinedLeftClickPicker

	inst.components.locomotor.runspeed = TUNING.WILSON_RUN_SPEED * 1.2

	inst.components.sanity.night_drain_mult = 0
	
	if TOPH_MOD_CONFIG["CHEAT_MODE"] == 1 then
		inst.components.hunger:SetMax(500)
	
		if ACTIONS.SPY then
			inst.components.worker:SetAction(ACTIONS.SPY, 1)
		end
		inst:AddTag("revealtraps")
		
		AddIngredientValues({"batwing"}, {meat=0.5, monster=0.5}, true)
		AddIngredientValues({"batwing_cooked"}, {meat=0.5, monster=0.5}, true)
		AddIngredientValues({"lotus_flower"}, {veggie=0.5}, true)	
		AddIngredientValues({"lotus_flower_cooked"}, {veggie=0.5}, true)	
		AddIngredientValues({"nectar_pod"}, {sweetener=0.5}, true)
		
		--Honestly, this should be its own mod, right here.
		AddIngredientValues({"plantmeat"}, {meat=0.5, monster=0.5, veggie=0.5}, true)
		AddIngredientValues({"plantmeat_cooked"}, {meat=0.5, veggie=0.5}, true)
		AddIngredientValues({"tuber_bloom_crop"}, {veggie=1}, true)	
		AddIngredientValues({"tuber_bloom_crop_cooked"}, {veggie=1}, true)
		
		--Because I can
        AddIngredientValues({"nightmarefuel"}, {inedible=1, magic=1})		
        
		--See about adding something for hedge clippings, just because.
	end

    inst.entity:AddLight()
    inst.Light:SetRadius(20)
    inst.Light:SetFalloff(.5)
    inst.Light:SetIntensity(.5)
    inst.Light:SetColour(128/255,80/255,0/255)
    inst.Light:Enable(true)
	
	if TOPH_MOD_CONFIG["VISIBLE_BLINDNESS"] == 1 then
		GetWorld().components.colourcubemanager:SetOverrideColourCube("images/colour_cubes/beaver_vision_cc.tex")
	end
end

return MakePlayerCharacter("toph", prefabs, assets, fn, start_inv)
